Subject: Re: [PATCH bpf-next 0/8] Simplify xdp_do_redirect_map()/xdp_do_flush_map() and XDP maps

From: Jesper Dangaard Brouer <[email-masked]>
Date: Wed, 18 Dec 2019 13:03:46 +0100

On Wed, 18 Dec 2019 12:39:53 +0100
Björn Töpel <[email-masked]> wrote:

> On Wed, 18 Dec 2019 at 12:11, Jesper Dangaard Brouer <[email-masked]> wrote:
> >
> > On Wed, 18 Dec 2019 11:53:52 +0100
> > Björn Töpel <[email-masked]> wrote:
> >  
> > >   $ sudo ./xdp_redirect_cpu --dev enp134s0f0 --cpu 22 xdp_cpu_map0
> > >
> > >   Running XDP/eBPF prog_name:xdp_cpu_map5_lb_hash_ip_pairs
> > >   XDP-cpumap      CPU:to  pps            drop-pps    extra-info
> > >   XDP-RX          20      7723038        0           0
> > >   XDP-RX          total   7723038        0
> > >   cpumap_kthread  total   0              0           0
> > >   redirect_err    total   0              0
> > >   xdp_exception   total   0              0  
> >
> > Hmm... I'm missing some counters on the kthread side.
> >  
> 
> Oh? Any ideas why? I just ran the upstream sample straight off.

Looks like it happened in commit: bbaf6029c49c ("samples/bpf: Convert
XDP samples to libbpf usage") (Cc Maciej).

The old bpf_load.c will auto attach the tracepoints... for and libbpf
you have to be explicit about it.

Can I ask you to also run a test with --stress-mode for
./xdp_redirect_cpu, to flush out any potential RCU race-conditions
(don't provide output, this is just a robustness test).

-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Principal Kernel Engineer at Red Hat
  LinkedIn: http://www.linkedin.com/in/brouer